#include <stdio.h>

/*
 * Beispiele fuer (math.) Funktionen der "Bauart"
 *    double f(double ...)
 */

double square(double x) {
    return x * x;
}

double half(double x) {
    return x / 2.0;
}

int main() {
    double x = 5.0;
	/*
	 * Zeiger auf eine Funktion der "Bauart"
	 *    double f(double ...)
	 */
    double (*p)(double);

    p = square;	/* einmal quadrieren ... */

    printf("x = %lf\n", x);
	/*
	 * Funktionsanwendung: (*p)(x)
	 * Denn: zuerst Zeiger dereferenzieren => *p
	 *       und dann erst haben wir eine Funktion => (*p),
	 *       die man mit Parametern "versorgen" kann => (*p)(x)
	 */
    printf("(*p)(x) = %lf\n", (*p)(x));

    p = half;	/* ... und das andere Mal halbieren :-) */

    printf("x = %lf\n", x);
    printf("(*p)(x) = %lf\n", (*p)(x));

    return 0;
}
