#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int main() {
	char *s;
	char *cons = "Hallo";

	    /*
	     * dynamisch Speicherplatz beschaffen fuer den
	     * Inhalt von cons + Nullbyte!
	     */
	s = calloc(sizeof(char), strlen(cons) + 1);
	if (!s) {
	    fprintf(stderr, "out of memory\n");
	    return 1;
	}

	strcpy(s, cons);

	puts(s);

	    /* erstes Zeichen veraendern */
	s[0] = 'X';

	puts(s);

	    /*
	     * nun machen wir auch noch eine saubere Fehlerbehandlung:
	     */
	char *tmp = realloc(s, sizeof(char) * (strlen(cons) + 1 + 1));
	if (!tmp) {
	    free(s);
	    fprintf(stderr, "out of memory\n");
	    return 1;
	}
	s = tmp;	/* ... jetzt aber dann wirklich die veraenderte Position zuweisen! */

	s[5] = 's';
	s[6] = '\0';

	puts(s);

	free(s);	/* ... zuerst geben wir den Speicherplatz frei ... */
	s = NULL;	/* ... und nun gehen wir noch sicher, dass kein Zugriff mehr moeglich! */

	return 0;
}
